CodeForces 238C World Eater Brothers

题意:

  输入n,表示有n个城市,分别为1~n,输入n-1组a,b,表示从a能走到b,求最少改变多少条路使得从其中的两个城市出发能走完所有的城市。

(http://blog.csdn.net/metalseed/article/details/8045038%20 与建树有关的东西 )

解题思路:

建立一棵树,断开一条边,把树分成两部分,计算这两部分的最小改变量

那么就变成了子树最小改变量的问题

dp[i]表示以i为根的子树需要的改变量

如果以root为起点,那么cost[root] = dp[root]   如果以这棵子树上的任意一个u为起点

则  cost[u] = dp[root] + u-root需要改变的量 - root-u需要改变的量

要使cost[u]最小,则(u-root需改变+root-u需改变)值最小

 1 #include <cstdio>
 2 #include <cstring>
 3 #include <iostream>
 4 #include <algorithm>
 5 #include <cmath>
 6 using namespace std;
 7 const int N = 1e5 + 10; //1e5是10的5次方
 8 struct Edge
 9 {
10     int from, to, dis, nex;
11 }edge[N<<1];
12 int head[N], edgenum;
13 void add(int u, int v, int d)
14 {
15     Edge E = { u, v, d, head[u] };
16     edge[edgenum] = E;
17     head[u] = edgenum++;
18 }
19 int dp[N];
20 int n, mx;
21 void dfs(int u, int fa, int val)
22 {
23     dp[u] = 0;
24     for (int i = head[u]; ~i; i = edge[i].nex)//~i表示取反,其实就是非零
25     {
26         int v = edge[i].to;
27         if (v == fa)continue;
28         dfs(v, u, val-edge[i].dis);
29         dp[u] += dp[v] + (edge[i].dis!=1);//如果括号里的成立则加1,否则加0
30     }
31     mx = max(mx, val);
32 }
33 int main()
34 {
35     while (cin >> n)
36     {
37         if (n == 1){ puts("0"); continue; }//puts 输出并换行 头文件cstdio
38         memset(head, -1, sizeof head);
39         edgenum = 0;
40         for (int i = 1, u, v; i < n; i++)
41         {
42             scanf("%d %d", &u, &v);
43             add(u, v, 1);
44             add(v, u, -1);
45         }
46         int ans = 1 << 30;
47         for (int i = 0, u, v; i < edgenum; i += 2)
48         {
49             u = edge[i].from; v = edge[i].to;
50             mx = -(1<<30);
51             dfs(u, v, 0);
52             int tmp = dp[u] - mx;
53             mx = -(1<<30);
54             dfs(v, u, 0);
55             tmp += dp[v] - mx;
56             ans = min(ans, tmp);
57         }
58         printf("%d\n", ans);
59     }
60     return 0;
61 }

时间: 2024-10-14 06:15:57

CodeForces 238C World Eater Brothers的相关文章

CodeForces 238C World Eater Brothers 树形dp

题目链接:点击打开链接 题意: 给定n个点的有向树 下面n-1行给出正向的边. 问: 修改尽可能小的边的方向,可以任选2个起点使得这两个点bfs能遍历完所有点. 思路: 枚举一条边,把树分成两部分,每次计算这两部分的最小花费. 那么这样就变成一个子树上的dp. 对于一棵树所需要修改的最小边方向的方法: 首先容易求出:dp[i]表示以i为根的子树,用i作为起点的花费. 此时若以root为起点则代价就是cost[root] = dp[root], 若以树中任意一点u为起点 则代价就是cost[u]

codeforces:855D Rowena Ravenclaw&#39;s Diadem分析和实现

题目大意: 提供n个对象,分别编号为1,...,n.每个对象都可能是某个编号小于自己的对象的特例或是成分.认为某个对象的特例的特例依旧是该对象的特例,即特例关系传递,同样一个对象的成分的成分依旧是该对象的成分.但是还需要注意一个对象的成分是该对象的所有特例的成分.每个对象都不可能是自己的特例或成分.要求解答之后的q个谜题,每个谜题提问两个对象是否是特例关系或成分关系. 输入级别:n,q<1e5 花了一个晚上才想到思路解了题目... 首先我们要先解决一个简单的问题,我将这道题目这样描述,对于一株多

【codeforces 718E】E. Matvey&#39;s Birthday

题目大意&链接: http://codeforces.com/problemset/problem/718/E 给一个长为n(n<=100 000)的只包含‘a’~‘h’8个字符的字符串s.两个位置i,j(i!=j)存在一条边,当且仅当|i-j|==1或s[i]==s[j].求这个无向图的直径,以及直径数量. 题解:  命题1:任意位置之间距离不会大于15. 证明:对于任意两个位置i,j之间,其所经过每种字符不会超过2个(因为相同字符会连边),所以i,j经过节点至多为16,也就意味着边数至多

Codeforces 124A - The number of positions

题目链接:http://codeforces.com/problemset/problem/124/A Petr stands in line of n people, but he doesn't know exactly which position he occupies. He can say that there are no less than a people standing in front of him and no more than b people standing b

Codeforces 841D Leha and another game about graph - 差分

Leha plays a computer game, where is on each level is given a connected graph with n vertices and m edges. Graph can contain multiple edges, but can not contain self loops. Each vertex has an integer di, which can be equal to 0, 1 or  - 1. To pass th

Codeforces Round #286 (Div. 1) A. Mr. Kitayuta, the Treasure Hunter DP

链接: http://codeforces.com/problemset/problem/506/A 题意: 给出30000个岛,有n个宝石分布在上面,第一步到d位置,每次走的距离与上一步的差距不大于1,问走完一路最多捡到多少块宝石. 题解: 容易想到DP,dp[i][j]表示到达 i 处,现在步长为 j 时最多收集到的财富,转移也不难,cnt[i]表示 i 处的财富. dp[i+step-1] = max(dp[i+step-1],dp[i][j]+cnt[i+step+1]) dp[i+st

Codeforces 772A Voltage Keepsake - 二分答案

You have n devices that you want to use simultaneously. The i-th device uses ai units of power per second. This usage is continuous. That is, in λ seconds, the device will use λ·ai units of power. The i-th device currently has bi units of power store

Educational Codeforces Round 21 G. Anthem of Berland(dp+kmp)

题目链接:Educational Codeforces Round 21 G. Anthem of Berland 题意: 给你两个字符串,第一个字符串包含问号,问号可以变成任意字符串. 问你第一个字符串最多包含多少个第二个字符串. 题解: 考虑dp[i][j],表示当前考虑到第一个串的第i位,已经匹配到第二个字符串的第j位. 这样的话复杂度为26*n*m*O(fail). fail可以用kmp进行预处理,将26个字母全部处理出来,这样复杂度就变成了26*n*m. 状态转移看代码(就是一个kmp

Codeforces Round #408 (Div. 2) B

Description Zane the wizard is going to perform a magic show shuffling the cups. There are n cups, numbered from 1 to n, placed along the x-axis on a table that has m holes on it. More precisely, cup i is on the table at the position x?=?i. The probl